/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2025 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package de.steamwar.teamserver.command;

import de.steamwar.command.SWCommand;
import de.steamwar.linkage.Linked;
import org.bukkit.entity.Player;

@Linked
public class SpeedCommand extends SWCommand {

    public SpeedCommand() {
        super("speed");
    }

    @Register(help = true)
    public void genericHelp(Player p, String... args) {
        p.sendMessage("/speed [1-10] - Setzte deine Flug- und Laufgeschindigkeit.");
        p.sendMessage("Aktuelle geschwindigkeit: " + (p.getFlySpeed() * 10F));
    }

    @Register
    public void speedCommand(Player p, float speed) {
        speed = speed / 10F;
        if (speed < -1F) {
            p.sendMessage("§7" + speed + " ist zu klein");
        } else if (speed > 1F) {
            p.sendMessage("§7" + speed + " ist zu hoch");
        } else {
            p.setFlySpeed(speed);
            p.setWalkSpeed(Math.min(speed + 0.1F, 1F));
            p.sendMessage("Aktuelle geschwindigkeit: " + (p.getFlySpeed() * 10F));
        }
    }

    @Register({"default"})
    public void speedCommand(Player p) {
        speedCommand(p, 1);
    }
}
